/* config */
var api_domain = "api.miaowoo.com";
var frames = [{
	name : 'rss',
	url : 'html/rss.html'

}, {
	name : 'home',
	url : 'html/home.html'

}, {
	name : 'new',
	url : 'html/new.html'
}];
var api_dbname = "comicdb";
var db, jpush_cid;
var systemType;
var today = new Date();
var needNotice = false;
var check_sql = "", check_tablename = "";
//用于全局判断SQL建立的表是否与原来的结构相同，如果不同需要删除该表
/**
 * 对Date的扩展，将 Date 转化为指定格式的String
 * 月(M)、日(d)、12小时(h)、24小时(H)、分(m)、秒(s)、周(E)、季度(q) 可以用 1-2 个占位符
 * 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)
 * eg:
 * (new Date()).pattern("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423
 * (new Date()).pattern("yyyy-MM-dd E HH:mm:ss") ==> 2009-03-10 二 20:09:04
 * (new Date()).pattern("yyyy-MM-dd EE hh:mm:ss") ==> 2009-03-10 周二 08:09:04
 * (new Date()).pattern("yyyy-MM-dd EEE hh:mm:ss") ==> 2009-03-10 星期二 08:09:04
 * (new Date()).pattern("yyyy-M-d h:m:s.S") ==> 2006-7-2 8:9:4.18
 */
Date.prototype.pattern = function(fmt) {
	var o = {
		"M+" : this.getMonth() + 1, //月份
		"d+" : this.getDate(), //日
		"h+" : this.getHours() % 12 == 0 ? 12 : this.getHours() % 12, //小时
		"H+" : this.getHours(), //小时
		"m+" : this.getMinutes(), //分
		"s+" : this.getSeconds(), //秒
		"q+" : Math.floor((this.getMonth() + 3) / 3), //季度
		"S" : this.getMilliseconds() //毫秒
	};
	var week = {
		"0" : "/u65e5",
		"1" : "/u4e00",
		"2" : "/u4e8c",
		"3" : "/u4e09",
		"4" : "/u56db",
		"5" : "/u4e94",
		"6" : "/u516d"
	};
	if (/(y+)/.test(fmt)) {
		fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}
	if (/(E+)/.test(fmt)) {
		fmt = fmt.replace(RegExp.$1, ((RegExp.$1.length > 1) ? (RegExp.$1.length > 2 ? "/u661f/u671f" : "/u5468") : "") + week[this.getDay() + ""]);
	}
	for (var k in o) {
		if (new RegExp("(" + k + ")").test(fmt)) {
			fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
		}
	}
	return fmt;
}
/**
 * 模仿PHP的strtotime()函数
 * strtotime('2012-07-27 12:43:43') OR strtotime('2012-07-27')
 * @return 时间戳
 */
function strtotime(str) {
	var _arr = str.split(' ');
	var _day = _arr[0].split('-');
	_arr[1] = (_arr[1] == null) ? '0:0:0' : _arr[1];
	var _time = _arr[1].split(':');
	for (var i = _day.length - 1; i >= 0; i--) {
		_day[i] = isNaN(parseInt(_day[i])) ? 0 : parseInt(_day[i]);
	};
	for (var i = _time.length - 1; i >= 0; i--) {
		_time[i] = isNaN(parseInt(_time[i])) ? 0 : parseInt(_time[i]);
	};
	var _temp = new Date(_day[0], _day[1] - 1, _day[2], _time[0], _time[1], _time[2]);
	return _temp.getTime();
}

/**
 *打开数据库
 */
function openDB(callback) {
	db = api.require('db');
	db.openDatabase({
		name : api_dbname
	}, function(ret, err) {
		if (!ret.status) {
			api.alert({
				msg : err.msg
			});
		} else {
			try {
				if (callback) {
					callback();
				}
			} catch (e) {
				alert(e)
			}
		}
	});

}

function checkTable() {
	var csql = "select * from sqlite_master where tbl_name='" + check_tablename + "'";
	selectSql(csql, checksqlCallback);
}

function checksqlCallback(ret) {
	if (eval(ret).length > 0) {		
		if (ret[0].sql != check_sql) {
			var drsql = "drop table IF EXISTS " + check_tablename;
			executeSql(drsql);
			executeSql(check_sql);
		}
	}
	else{
		executeSql(check_sql);
	}
}

function createAllTable() {
	//订阅表
	var rsql = "CREATE TABLE api_rss(comic_id int(6),member_id int(11),chapter_id int(8),";
	rsql += "title char(50),readchapter char(10),nowchapter char(10),pic varchar(150),renew int(1),";
	rsql += "type int(1),totalpage int(3) default 1,readpage int(3) default 1)";
	check_sql = rsql;
	check_tablename = "api_rss";
	checkTable();

	/*
	 var dsql = 'delete from api_rss where title="undefined" or nowchapter="undefined" or pic="undefined"';
	 executeSql(dsql);
	 */
}

/**
 *关闭数据库
 */
function closeDB() {
	if ( typeof (db) != "undefined") {
		db = api.require('db');
		db.closeDatabase({
			name : api_dbname
		}, function(ret, err) {
			if (!ret.status) {
				api.alert({
					msg : err.msg
				});
			}
		});
	}
}

/**
 *数据库事务  begin、commit、rollback
 */
function transactionDB(operation) {
	db = api.require('db');
	db.transaction({
		name : api_dbname,
		operation : operation
	}, function(ret, err) {
		if (!ret.status) {
			api.alert({
				msg : err.msg
			});
		}
	});
}

/**
 *执行SQL语句
 * @param {Object} sql
 */
function executeSql(sql) {
	db = api.require('db');
	db.executeSql({
		name : api_dbname,
		sql : sql
	}, function(ret, err) {
		if (ret.status) {
			//api.alert({msg:'执行SQL成功:'+sql});
		} else {
			api.alert({
				msg : err.msg
			});
		}
	});
}

/**
 * 查询SQL语句
 * @param {Object} sql
 */
function selectSql(sql, callback) {
	db = api.require('db');
	db.selectSql({
		name : api_dbname,
		sql : sql
	}, function(ret, err) {
		if (ret.status) {
			data = ret.data
		} else {
			data = false;
		}
		callback(data);
	});
}

/**
 * ajax执行函数
 * @param {Object} url
 * @param {Object} values
 * @param {Object} callback
 */
function doAjax(url, values, callback) {
	api.ajax({
		url : url,
		timeout : 5,
		returnAll : false,
		data : {
			values : values
		}
	}, function(ret, err) {
		if (ret) {
			try {
				callback(ret);
			} catch (e) {
				alert(e)
			}
		} else {
			if ( typeof (connectError) != "undefined") {
				connectError();
			} else {
				api.alert({
					msg : ('请检查您的网络！')
				});
			}
			/*
			 api.alert({
			 msg : ('错误码：' + err.code + '；错误信息：' + err.msg + '网络状态码：' + err.statusCode + JSON.stringify(ret))
			 });
			 */
		}
	});
}

function openMainFrame(index, data) {
	var $header = $api.dom('header');
	$api.fixIos7Bar($header);
	var $body = $api.dom('body');
	var $footer = $api.byId('footer');
	var header_h = $api.offset($header).h;
	var body_h = $api.offset($body).h;
	var footer_h = $api.offset($footer).h;
	var rect_h = body_h - header_h - footer_h;
	var name = frames[index]['name'];
	var url = frames[index]['url'];
	api.openFrame({
		name : name,
		url : url,
		rect : {
			x : 0,
			y : header_h,
			w : 'auto',
			h : rect_h
		},
		pageParam : data
	});
}

function openComic(obj, cid) {
	var id = $api.attr(obj, 'data-id');
	var data = {
		id : id
	}
	openWin('comic', 'comic.html', data);
}

function openChapter(obj) {
	var id = $api.attr(obj, 'data-id');
	var data = {
		id : id
	};
	openWin('chapter', 'chapter.html', data);
}

function openWin(name, url, data) {
	api.openWin({
		name : name,
		url : url,
		pageParam : data
	});
}

function setRefreshHeader() {
	api.setRefreshHeaderInfo({
		visible : true,
		bgColor : '#ccc',
		textColor : '#fff',
		textDown : '下拉刷新...',
		textUp : '松开刷新...',
		showTime : true
	}, function(ret, err) {
		render();
		api.refreshHeaderLoadDone();
	});
}

function comicCallback(ret) {
	//alert(JSON.stringify(ret));
	var comicHtml = "";
	if ( typeof (page) != "undefined" && page > 1) {
		comicHtml = $("#comicList").html();
	}
	for (var i in ret) {
		comicHtml += '<li class="cfb" data-id="' + ret[i].id + '" onclick="openComic(this)">';
		comicHtml += '	<div class="fl">';
		comicHtml += '		<img src="' + ret[i].pic + '" alt="">';
		comicHtml += '		<span class="t2 c1 lim tl">' + ret[i].title + '</span>';
		comicHtml += '		<span class="t5 c1 dib tl">' + ret[i].catename + '</span>';
		comicHtml += '		<span class="t5 c1 dib tl">' + ret[i].chapter + '</span>';
		comicHtml += '		<span class="star dib c2 tl t5"><em><i style="width:100%"></i></em>10.0</span>';
		comicHtml += '	</div>';
		comicHtml += '	<div class="fr">';
		comicHtml += '		<span class="t5 c1 dib tl">' + ret[i].update_strtime + '</span>';
		comicHtml += '	</div>';
		comicHtml += '</li>';
	}
	$("#comicList").html(comicHtml);
}